{ ****** PARAMETRE ****** }

Type ModeParam = ( MP_Rien, MP_Flip, MP_Egal );

     TpParam = Record
         n  : string[4];
         mp : ModeParam;
       End;

     ParamRef = (
      PR_NIL,
      PR_MDA,  PR_CGA,  PR_COM,  PR_COM1, PR_COM2, PR_COM3, PR_COM4,
      PR_BUF,  PR_HELP, PR_SLOW, PR_SIL,  PR_ED,   PR_ER,   PR_EI,
      PR_EC,   PR_EA,   PR_LPT,  PR_TLX,
      PR_DERNIER
      );


Const
      CFGFileName : string[12] = 'CAPTEL.CFG';

      TabParam : array[Succ(PR_NIL)..Pred(PR_DERNIER)] of TpParam = (
        ( n:'MDA';  mp:MP_Rien ),  { ecran mono }
        ( n:'CGA';  mp:MP_Rien ),  { ecran CGA 25 lignes }
        ( n:'COM';  mp:MP_Egal ),  { COM=adresse,irq }
        ( n:'COM1'; mp:MP_Rien ),  { COM1 (quivalent de COM=$3F8,4) }
        ( n:'COM2'; mp:MP_Rien ),  { COM2 }
        ( n:'COM3'; mp:MP_Rien ),  { COM3 }
        ( n:'COM4'; mp:MP_Rien ),  { COM4 }
        ( n:'BUF';  mp:MP_Egal ),  { BUF=in,out }
        ( n:'?';    mp:MP_Rien ),  { ? affiche une aide }
        ( n:'SLOW'; mp:MP_Flip ),  { SLOW : ralenti l'init. minitel }
        ( n:'SIL';  mp:MP_Flip ),  { SIL  : ignore minitel }
        ( n:'ED';   mp:MP_Flip ),  { ED   : emule DRCS (M2) }
        ( n:'ER';   mp:MP_Flip ),  { ER   : emule RTIC (M1B) }
        ( n:'EI';   mp:MP_Flip ),  { EI   : emule insertion (M2) }
        ( n:'EC';   mp:MP_Flip ),  { EC   : mule clear soul (M2) }
        ( n:'EA';   mp:MP_Flip ),  { EA   : mule auto roll on/off }
        ( n:'LPT';  mp:MP_Egal ),  { LPT=  : 1,2, 3 ... more? }
        ( n:'TLX';  mp:MP_Egal )   { TLX=  : fixe un nom de telix }
        );

function FileParam( var f : text ) : boolean;
var s : string;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
begin
  FileParam := TRUE;

  { recherche d'abord dans le rpertoire courant }
  Assign(f,CFGFileName);
  reset(f);
  if IoResult=0 then exit;

  { recherche dans le rpertoire o est l'executable }
  s := ParamStr(0);
  if s<>'' then
    begin
      FSplit(s,r,n,e);
      Assign(f,r+CFGFileName);
      reset(f);
      if IoResult=0 then exit;
    end;

  { recherche dans le PATH dos }
  s := FSearch(CFGFileName,GetEnv('PATH'));
  if s<>'' then
    begin
      Assign(f,s);
      reset(f);
      if IoResult=0 then exit;
    end;

  FileParam := FALSE;
end;


Function ValBin( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
    cld
    push ds
    lds  si, [S]
    lodsb               { lire la longueur de la chaine }
    xor  ah, ah         { longueur de la chaine dans AX }

    mov  cx, ax
    jcxz @FALSE         { saute si chaine vide }
    xor  bx, bx
    xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
    lodsb               { lit le car }
    sub  al, '0'        { -'0' }
    cmp  al, 1
    ja   @FALSE         { erreur de syntaxe! '0' ou '1' seulement ! }
    cmc                 { car, si al=1 => cf=0, si al<1 => cf=1 !! }
    rcl  bx, 1          { rotate with carry }
    rcl  dx, 1
    jc   @FALSE         { depassement de capacit 16 bits ! }
    loop @BOUCLE

    lds  si, [x]
    mov  [si], bx
    mov  [si+2], dx     { ecrit le resultat }
    mov  al, TRUE       { sort avec TRUE }
    JMP  @FIN
@FALSE:
    XOR  AL, AL
@FIN:
    pop  ds
End;


Function ValHex( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
        cld
        push ds
        lds  si, [S]
        lodsb
        xor  ah, ah         { longueur de la chaine dans AX }
        mov  cx, ax
        jcxz @FALSE         { saute si vide }
        xor  bx, bx
        xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
        lodsb               { lit le car }
        cmp  al, 'a'
        jb   @03
        cmp  al, 'f'
        ja   @FALSE         { car incorrecte }
        sub  al, 32         { -32!  UpCase(al) }
        jmp  @05
@03:
        cmp  al, '0'
        jb   @FALSE
        cmp  al, '9'
        ja   @04
        {
          0..9
        }
        sub  al, '0'
        jmp  @CONT
@04:
        cmp  al, 'A'
        jb   @FALSE
        cmp  al, 'F'
        ja   @FALSE
        {
          A..F
        }
@05:
        sub  al, 'A'-10
@CONT:
        test dx, 0F000h
        jnz  @FALSE         { depassement de capacit }
        push cx             { sauve cx }
        mov  cl, 4
        shl  dx, cl         { dx*16  dx= xxxx xxxx xxxx 0000 }
        mov  ah, bh         {        ah= ???? xxxx           }
        shr  ah, cl         {        ah= 0000 ????           }
        or   dl, ah         {        dx= xxxx xxxx xxxx ???? }
        shl  bx, cl
        or   bl, al
        pop  cx             { restore cx }
        loop @BOUCLE

        lds  si, [x]
        mov  [si], bx
        mov  [si+2], dx     { ecrit le resultat }
        mov  al, TRUE       { sort avec TRUE }
        JMP  @FIN
@FALSE:
        xor  al, al
@FIN:
        pop  ds
End;


{ traduction en fonction du type de nombre }

Function ValX( Var S : String; Var x : Longint ) : Boolean;
Var SN  : String[32];
    Err : Word;
Begin
  If (S<>'') And (Length(S)<SizeOf(SN)) Then
    Case UpCase(S[1]) Of
      '%','B' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValBin(SN,x);
                End;
      '$','H' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValHex(SN,x);
                End;
      '#','D' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  Val(SN,x,Err);
                  ValX := Err=0;
                End;
    Else
      Case UpCase(S[Length(S)]) Of
        'B' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValBin(SN,x);
              End;
        'H' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValHex(SN,x);
              End;
        'D' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                Val(SN,x,Err);
                ValX := Err=0;
              End;
      Else
        Begin
          Val(S,x,Err);
          ValX := Err=0;
        End;
      End
    End
  Else ValX := FALSE;
End;


Function StrStr( var s : String; nPar : Word;
                 var result : String; SizeMax : Byte ) : boolean;
var i : word;
    n : String;
begin
  i := 1;
  while nPar>1 do
    begin
      while (i<=length(s)) and (s[i]<>',') do inc(i);
      if i>length(s) then
        begin
          result := '';
          StrStr := TRUE;
          exit;
        end;
      dec(nPar);
      inc(i);
    end;
  n := '';
  while (i<=length(s)) and (s[i]<>',') do
    begin
      inc(n[0]);
      n[length(n)] := s[i];
      inc(i);
    end;
  If SizeMax<Length(n) Then n[0] := Char(SizeMax);

  Result := n;
  StrStr := TRUE;
end;



Function StrVal( var s : String; nPar : Word;
                 var result : Word; default : Word ) : Boolean;
Var n : String[20];
    x : Longint;
Begin
 If StrStr(s,nPar,n,SizeOf(n)-1) Then
  If n='' Then
   Begin
    result := default;
    StrVal := TRUE;
   End
  Else
   Begin
    If ValX(n,x) And (x>=0) And (x<=65535) then
     Begin
      result := Word(x);
      StrVal := TRUE;
     End
    Else StrVal := FALSE;
   End
 Else StrVal := FALSE;
End;


Procedure ConfigErreur( txt : string; nLig, nParam : Word );
Begin
 If nLig>0 Then Writeln(txt,'  ligne n',nLig,'  param.n',nParam)
 Else Writeln(txt,'   param.n',nParam);
End;


Function  TraiteOption( p : TpParam; Plus : boolean; var sp : string
                      ) : String;
Var i  : word;
    t  : Word;
    Ok : Boolean;
    pr : ParamRef;
Begin
 For i := 1 To Length(p.n) Do p.n[i] := UpCase(p.n[i]);

 For pr := Succ(PR_NIL) To Pred(PR_DERNIER) Do
  If TabParam[pr].n=p.n Then
   Begin
    If (TabParam[pr].mp<>p.mp) And
       Not((p.mp=MP_Rien) And (TabParam[pr].mp=MP_Flip)) Then
      Begin
       TraiteOption := 'Option mal utilise';
       Exit;
      End;

    Ok := TRUE;

    Case pr Of
     PR_MDA  : VideoMode := VMODE_MDA;
     PR_CGA  : VideoMode := VMODE_CGA;
     PR_COM  : If StrVal(sp,1,ComUART,0) And
                 (ComUART And 7=0) And
                 StrVal(sp,2,t,ComIRQ) And
                 (t<16) Then
                Begin
                 ComIRQ := Byte(t);
                 TraiteOption := '';
                End
              Else Ok := FALSE;
     PR_COM1 : Begin
                ComUART := Memw[$0040:$0000];
                ComIRQ  := 4;
               End;
     PR_COM2 : Begin
                ComUART := Memw[$0040:$0002];
                ComIRQ  := 3;
               End;
     PR_COM3 : Begin
                ComUART := Memw[$0040:$0004];
                ComIRQ  := 4;
               End;
     PR_COM4 : Begin
                ComUART := Memw[$0040:$0006];
                ComIRQ  := 3;
               End;
     PR_BUF  : Ok := StrVal(sp,1,ComIn,ComIn) And
                     StrVal(sp,2,ComOut,ComOut) And
                     (ComIn>=256) And (ComOut>=256);
     PR_HELP : NeedHelp := TRUE;
     PR_SLOW : ComSlow := Plus;
     PR_SIL  : ComSilence := Plus;
     PR_ED   : EmulDRCS := Plus;
     PR_ER   : EmulRTIC := Plus;
     PR_EI   : EmulInsLow := Plus;
     PR_EC   : EmulC15Clr := Plus;
     PR_EA   : EmulAuto := Plus;
     PR_LPT  : Ok := StrVal(sp,1,LPTNum,LPTNum);
     PR_TLX  : TelixStr := sp;
    Else Ok := FALSE;
    End;

    If Ok Then TraiteOption := ''
    Else TraiteOption := 'Paramtre incorrect';

    Exit;
   End;
 TraiteOption := 'Option inconnu';
End;



Function AnalyseOption( Var p : TpParam; Var Plus : Boolean; Var v : String ) : Boolean;
Var x : Word;
Begin
 If (v<>'') And ((v[1]='/') Or (v[1]='-')) Then
  Begin
   If v[Length(v)]='+' then
    Begin
     p.n  := Copy(v,2,length(v)-2);
     p.mp := MP_Flip;
     v    := '';
     Plus := TRUE;
    End
   Else
    If v[Length(v)]='-' then
     Begin
      p.n  := Copy(v,2,length(v)-2);
      p.mp := MP_Flip;
      v    := '';
      Plus := FALSE;
     End
    Else
     Begin
      x := Pos('=',v);
      If x=0 Then
       Begin
        p.n  := Copy(v,2,length(v)-1);
        p.mp := MP_Rien;
        v    := '';
        Plus := TRUE;
       End
      Else
       Begin
        p.n  := Copy(v,2,x-2);
        p.mp := MP_Egal;
        v    := Copy(v,x+1,255);
        Plus := FALSE;
       End;
     End;
   AnalyseOption := TRUE;
  End
 Else AnalyseOption := FALSE;
End;


Function TraiteParam( s : String; nLig, nParam : Word ) : Boolean;
Var p      : TpParam;
    Plus   : Boolean;
Begin
 If AnalyseOption(p,Plus,s) Then
  Begin
   s := TraiteOption(p,Plus,s);
   If s<>'' Then
    Begin
     ConfigErreur(s,nLig,nParam);
     TraiteParam := FALSE;
     Exit;
    End;
  End
 Else
  Begin
   ConfigErreur('Erreur de syntaxe',nLig,nParam);
   TraiteParam := FALSE;
   Exit;
  End;
 TraiteParam := TRUE;
End;


Function ChargeParamLigne : Boolean;
Var nParam : Byte;
Begin
 For nParam := 1 To ParamCount Do
  Begin
   If Not(TraiteParam(ParamStr(nParam),0,nParam)) Then
    Begin
     ChargeParamLigne := FALSE;
     Exit;
    End;
  End;
 ChargeParamLigne := TRUE;
End;


Function TraiteLigne( Var Lig : String; nLig : Word ) : Boolean;
Var s      : String;
    i      : Byte;
    nParam : Word;
Begin
 nParam := 0;
 i := 1;
 While i<=Length(Lig) Do
  Begin
   If Lig[i]<>' ' Then
    Begin
     s := '';
     Repeat
      Inc(s[0]);
      s[Length(s)] := Lig[i];
      Inc(i);
     Until (i>Length(Lig)) Or (Lig[i]=' ');

     Inc(nParam);

     If Not(TraiteParam( s, nLig, nParam )) Then
      Begin
       TraiteLigne := FALSE;
       Exit;
      End;
    End
   Else Inc(i);
  End;
 TraiteLigne := TRUE;
End;


Function ChargeParamFile( Var f : Text ) : Boolean;
Var nLig : Word;
    Lig  : String;
Begin
 nLig := 0;
 While Not(Eof(f)) Do
  Begin
   Inc(nLig);
   Readln(f,Lig);
   If Lig<>'' Then
    Begin
     If Not(TraiteLigne(Lig,nLig)) Then
      Begin
       ChargeParamFile := FALSE;
       Exit;
      End;
    End
  End;
 ChargeParamFile := TRUE;
End;


Function ChargeParam : Boolean;
Var f : Text;
Begin
 If FileParam(f) Then
  Begin

   If Not(ChargeParamFile(f)) Then
    Begin
     ChargeParam := FALSE;
     Close(f);
     Exit;
    End;

   Close(f);
  End;

 ChargeParam := ChargeParamLigne;
End;
