{$A+,B-,E-,F-,I-,N-,O-,V- }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit StrTools;

interface

type Buffer = array[0..60000] of byte;
     PBuffer = ^Buffer;

procedure StrConc( var dest, sour : string );
procedure StrPointer( var s : string; p : pointer );
procedure StrInt( var s : string; x : longint );
procedure StrHexByte( var s : string; x : byte );
procedure StrHexWord( var s : string; x : word );
procedure StrHexLong( var s : string; p : longint );
procedure Str_Int( var s : string; x : longint; surf : integer );
procedure StrXInt( var s : string; x : longint; c : char; surf : integer );
procedure Str0Int( var s : string; x : longint; surf : integer );
procedure StrOInt( var s : string; x : longint; surf : integer );
procedure StrIntO( var s : string; x : longint );

procedure StrReal( var s : string; x : real; surf, decim : integer );
procedure StrXReal( var s : string; x : real; fc : char; surf, decim : integer );
procedure Str0Real( var s : string; x : real; surf, decim : integer );
procedure StrRealO( var s : string; x : real; surf, decim : integer );
procedure StrXRealO( var s : string; x : real; fc : char; surf, decim : integer );
procedure StrOReal( var s : string; x : real; surf, decim : integer );

procedure StrReel( var s : string; x : real; surf, decim : integer );
procedure StrXReel( var s : string; x : real; fc : char; surf, decim : integer );
procedure StrReelO( var s : string; x : real; surf, decim : integer );
procedure Str0Reel( var s : string; x : real; surf, decim : integer );
procedure StrXReelO( var s : string; x : real; fc : char; surf, decim : integer );
procedure StrOReel( var s : string; x : real; surf, decim : integer );

procedure StrUpCase( var s : string );
function  StrComp( var Refer, Sujet : string; MinMaj : boolean ) : integer;
procedure StrNorm( var s : string );

procedure StrPlaneLeft( var s : string ); { "Pln" pour "Plane" }
procedure StrPlaneRight( var s : string );
procedure StrPlane( var s : string );

procedure StrDate( var dest : string; j, m, a, md : word );
procedure StrPackDate( var dest : string; date : longint; md : word );
procedure StrTime( var dest : string; h, m, s, s100, md : word );
procedure StrPackTime( var dest : string; date : longint; md : word );

procedure StrDelChar(var texte : string; c : char);
procedure _StrChgChar(var texte : string; pos : integer; lg : integer; CharEx, CharNew : char);
procedure StrChgChar(var texte : string; CharEx, CharNew : char);
procedure StrTrunc(var texte : string; max : integer );
procedure StrInsert( var dest, sour : string; pos : integer );
procedure StrInsChar( var texte : string; pos, nb : integer; c : char );
procedure StrDel( var texte : string; pos, nb : integer );
procedure StrFill( var texte : string; pos, nb : integer; c : char );
function  StrPosChar( var s : string; pos : integer; c : char ) : word;
procedure StrOneSpace( var sour : string );
procedure StrJoin( var p; lg, nb : word; var dest : string; lg_max : word );
procedure UnJoinStr( var sour; lg_s : word; var dest; lg_d : Byte; nb_d : word;
                     SpcTrunc, OptSpace, Centre : boolean );

const LgStdSep  = 3;
      StdSep  : array[1..LgStdSep] of char = (' ','/',',');

      Sep_Espace    : char = ' ';
      Sep_Guillemet : char = '"';
      Sep_Etoile    : char = '*';
      Sep_Plus      : char = '+';
      Sep_Virgule   : char = ',';
      Sep_Moins     : char = '-';
      Sep_Point     : char = '.';
      Sep_Slash     : char = '/';
      Sep_2Points   : char = ':';
      Sep_PointVirg : char = ';';
      Sep_AntiSlash : char = '\';
      Sep_UnderScore: char = '_';

function  _StrPartCount( var sour : string; var p; lgTab : word ) : word;
procedure _StrPart( var sour : string; num : word;
                    var dest : string; lg_max : word;
                    var p; lgTab : word );
function  _StrPartLength( var sour : string; num : word;
                          var p; lgTab : word ) : word;
function  _StrPartVal( var sour : string; num : word;
                       var result : longint; default : longint;
                       var p; lgTab : word ) : boolean;
procedure _StrRest( var sour : string; num : word;
                    var dest : string; lg_max : word;
                    var p; lgTab : word );
function  _StrRestLength( var sour : string; num : word;
                          var p; lgTab : word ) : word;

function  StrPartCount( var sour : string ) : word;
procedure StrPart( var sour : string; num : word;
                   var dest : string; lg_max : word );
function  StrPartLength( var sour : string; num : word ) : word;
function  StrPartVal( var sour : string; num : word;
                      var result : longint; default : longint ) : boolean;
procedure StrRest( var sour : string; num : word;
                   var dest : string; lg_max : word );
function  StrRestLength( var sour : string; num : word ) : word;

function  MemComp( var x1, x2; lg : word ) : integer;
function  AlphaChar( c : char ) : boolean;
function  NumChar( c : char ) : boolean;
procedure DelCtrlChar( var s : string );

procedure VdtIbm( var sour, dest : string );
procedure IbmVdt( var sour, dest : string );

type EVTAig = (VT_NUL,
               VT_CODE,
               VT_SEP,
               VT_US,
               VT_SS2,
               VT_ESC,
               VT_PRO1,
               VT_PRO2,
               VT_PRO3,
               VT_ISO2022,
               VT_ISO6429,
               VT_REP,
               VT_FILT);

type EVTRec = record
         AigR   : EVTAig;      { aiguillage resultat }
         cAig   : word;        { aiguillage courant }
         LgR    : word;        { longueur rel du mot trait }
         dest   : ^string;     { destination o ecrire le mot }
         lg_max : byte;        { longueur max a crire }
       end;

procedure InitVdtTerm( var s : EVTRec; dest : pointer; lg_max : byte );
function  ExtractVdtTerm( ncar : char; var s : EVTRec ) : boolean;

function  _ValHex( var s : string; deb : word;
                   var result : longint ) : boolean;
function  _ValBin( var s : string; deb : word;
                   var result : longint ) : boolean;
function  ValDec( var s : string; var result : longint ) : boolean;
function  ValHex( var s : string; var result : longint ) : boolean;
function  ValBin( var s : string; var result : longint ) : boolean;
function  ValX( var s : string; var result : longint ) : boolean;
function  ValReal( var s : string; var result : real ) : boolean;


function  DayNumber( j, m, a : word ) : longint;
function  WeekDay( j, m, a : word ) : word;
function  DayNumberPack( d : longint ) : longint;
function  WeekDayPack( d : longint ) : word;

implementation

{$L STRT.OBJ }

procedure StrConc( var dest, sour : string ); external;
procedure StrPointer( var s : string; p : pointer ); external;
procedure StrHexByte( var s : string; x : byte ); external;
procedure StrHexWord( var s : string; x : word ); external;
procedure StrHexLong( var s : string; p : longint ); external;
procedure StrPlaneLeft( var s : string ); external;
procedure StrPlaneRight( var s : string ); external;
procedure StrDelChar( var texte : string; c : char); external;
procedure _StrChgChar(var texte : string; pos : integer; lg : integer; CharEx, CharNew : char); external;
procedure StrTrunc( var texte : string; max : integer ); external;
procedure StrInsert( var dest, sour : string; pos : integer ); external;
procedure StrInsChar( var texte : string; pos, nb : integer; c : char ); external;
procedure StrDel( var texte : string; pos, nb : integer ); external;
procedure StrFill( var texte : string; pos, nb : integer; c : char ); external;
procedure StrInt( var s : string; x : longint ); external;
procedure Str_Int( var s : string; x : longint; surf : integer ); external;
function  StrPosChar( var s : string; pos : integer; c : char ) : word; external;

procedure StrUpCase( var s : string ); external;
function  MemComp( var x1, x2; lg : word ) : integer; external;
function  StrComp( var Refer, Sujet : string; MinMaj : boolean ) : integer; external;
procedure StrNorm( var s : string ); external;

function  _ValHex( var s : string; deb : word;
                   var result : longint ) : boolean; external;
function  _ValBin( var s : string; deb : word;
                   var result : longint ) : boolean; external;

{$L STRVDT.OBJ }

procedure IbmVdt( var sour, dest : string ); external;
procedure VdtIbm( var sour, dest : string ); external;
procedure DelCtrlChar( var s : string ); external;




procedure StrChgChar( var texte : string; CharEx, CharNew : char );
begin
  _StrChgChar(texte,1,length(texte),CharEx,CharNew);
end;

procedure StrXInt( var s : string; x : longint; c : char; surf : integer );
var i : word;
begin
  i := length(s);
  Str_Int(s,x,surf);
  _StrChgChar(s,i+1,length(s)-1,' ',c);
end;

procedure Str0Int( var s : string; x : longint; surf : integer );
var i : word;
begin
  i := length(s);
  Str_Int(s,x,surf);
  _StrChgChar(s,i+1,length(s)-i,' ','0');
end;

procedure StrIntO( var s : string; x : longint );
var i : word;
begin
  i := length(s);
  StrInt(s,x);
  _StrChgChar(s,i+1,length(s)-i,'0','O');
end;

procedure StrOInt( var s : string; x : longint; surf : integer );
var i : word;
begin
  i := length(s);
  Str_Int(s,x,surf);
  _StrChgChar(s,i+1,length(s)-i,'0','O');
  _StrChgChar(s,i+1,length(s)-i,' ','O');
end;


procedure StrReal( var s : string; x : real; surf, decim : integer );
var n : ^string;
    c : char;
    l : byte;
begin
  l  := length(s);
  c  := s[l];
  n  := @s[l];
  n^ := '';
  str(x:surf:decim,n^);
  inc(l,length(n^));
  n^[0] := c;
  s[0] := char(l);
end;


procedure StrXReal( var s : string; x : real; fc : char; surf, decim : integer );
var n : ^string;
    c : char;
    l : byte;
begin
  l  := length(s);
  c  := s[l];
  n  := @s[l];
  n^ := '';
  str(x:surf:decim,n^);
  StrChgChar(n^,' ',fc);

  inc(l,length(n^));
  n^[0] := c;
  s[0] := char(l);
end;


procedure Str0Real( var s : string; x : real; surf, decim : integer );
begin
  StrXReal(s,x,'0',surf,decim);
end;


procedure StrRealO( var s : string; x : real; surf, decim : integer );
var n : ^string;
    c : char;
    l : byte;
begin
  l  := length(s);
  c  := s[l];
  n  := @s[l];
  n^ := '';
  str(x:surf:decim,n^);
  StrChgChar(n^,'0','O');

  inc(l,length(n^));
  n^[0] := c;
  s[0] := char(l);
end;


procedure StrXRealO( var s : string; x : real; fc : char; surf, decim : integer );
var n : ^string;
    c : char;
    l : byte;
begin
  l  := length(s);
  c  := s[l];
  n  := @s[l];
  n^ := '';
  str(x:surf:decim,n^);
  StrChgChar(n^,' ',fc);
  StrChgChar(n^,'0','O');

  inc(l,length(n^));
  n^[0] := c;
  s[0] := char(l);
end;


procedure StrOReal( var s : string; x : real; surf, decim : integer );
begin
  StrXRealO(s,x,'O',surf,decim);
end;


procedure StrReel( var s : string; x : real; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrReal(s,x,surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure StrXReel( var s : string; x : real; fc : char; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrXReal(s,x,fc,surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure Str0Reel( var s : string; x : real; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrXReal(s,x,'0',surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure StrReelO( var s : string; x : real; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrRealO(s,x,surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure StrXReelO( var s : string; x : real; fc : char; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrXRealO(s,x,fc,surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure StrOReel( var s : string; x : real; surf, decim : integer );
var pos : integer;
begin
  pos := length(s);
  StrXRealO(s,x,'O',surf,decim);
  _StrChgChar(s,pos+1,length(s)-pos,'.',',');
end;


procedure StrPlane( var s : string );
{ vire les espaces de debut et de fin }
begin
  StrPlaneRight(s);
  StrPlaneLeft(s);
end;

procedure StrDate( var dest : string; j, m, a, md : word );
  { x xx xx xx x x xx xx xx                                           }
  { | |  |  |  | | |  |  |->sparateur: 0=>'/' 1=>' ' 2=>'-' 3=>#9    }
  { | |  |  |  | | |  |->anne: 0=>AA 1=>AAAA 2=>rien 3=>0            }
  { | |  |  |  | | |->mois: 0=>MM 1=>?M 2=>mmm 4=>?m                  }
  { | |  |  |  | |->jour: 0=>JJ 1=?J                                  }
  { | |  |  |  |->jour: 0=>prcd de ' '   1=>prcd de '0'         }
  { | |  |  |->jour: 0=>rien 1=>jjj 2=>?j 3=>0                        }
  { | |  |->mode mmm: 0=>rien 1=>min 2=>Min 3=>MAJ                    }
  { | |->mode jjj: 0=>rien 1=>min 2=>Min 3=>MAJ                       }
  { |->0=>0->O  1=>rien                                            }

  const Md_ChgChar   = 14;
        Md_Modejjj   = 12;
        Md_Modemmm   = 10;
        Md_jjj       = 8;
        Md_mJJ       = 7;
        Md_JJ        = 6;
        Md_MM        = 4;
        Md_AA        = 2;

        Tab_Sem : array[0..6] of string[3] = (
          'Dim','Lun','Mar','Mer','Jeu','Ven','Sam'
          );
        Tab_Semaine  : array[0..6] of string[8] = (
          'Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'
          );

        Tab_Moi : array[1..12] of string[3] = (
          'jan','fev','mar','avr','mai','jun','jul','aou','sep','oct','nov','dec'
          );

        Tab_Mois : array[1..12] of string[9] = (
          'janvier','fevrier','mars','avril','mai','juin','juillet','aout','septembre','octobre','novembre','decembre'
          );

var t : string[9];

  procedure AjustConc_t( Mode : byte );
  var i : word;
  begin
    case Mode of
      1 : { min }
          for i := 1 to length(t) do
            if (t[i]>='A') and (t[i]<='Z') then inc(t[i],32);
      2 : begin { Min }
            for i := 2 to length(t) do
              if (t[i]>='A') and (t[i]<='Z') then inc(t[i],32);
            if length(t)>0 then t[1] := UpCase(t[1]);
          end;
      3 : StrUpCase(t);
    end;
    StrConc(dest,t);
  end;

var c   : byte;
    sep : char;
    deb : word;
begin
  deb := length(dest)+1; { note la position de dpart }

  case md and 3 of
    0 : sep := '/';
    1 : sep := ' ';
    2 : sep := '-';
    3 : sep := #09;
  end;

  { jjj }
  c := (md shr Md_jjj) and 3;
  if c=1 then
    begin { jjj }
      t := Tab_Sem[WeekDay(j,m,a)];
      AjustConc_t((md shr Md_Modejjj) and 3);
      inc(dest[0]); dest[length(dest)] := ' ';
    end
  else
    if c=2 then
      begin { ?j }
        t := Tab_Semaine[WeekDay(j,m,a)];
        AjustConc_t((md shr Md_Modejjj) and 3);
        inc(dest[0]); dest[length(dest)] := ' ';
      end;

  { JJ }
  if (md shr Md_JJ) and 1=0 then
    { JJ }
    if ((md shr Md_mJJ) and 1)=0 then Str_Int(dest,j,2)
    else Str0Int(dest,j,2)
  else StrInt(dest,j); { ?J }

  { sep }
  inc(dest[0]); dest[length(dest)] := sep;

  { MM }
  case (md shr Md_MM) and 3 of
    0 :   { MM }
        Str0Int(dest,m,2);
    1 :   { ?M }
        StrInt(dest,m);
    2 : begin
          t := Tab_Moi[m];
          AjustConc_t((md shr Md_Modemmm) and 3);
        end;
    3 : begin
          t := Tab_Mois[m];
          AjustConc_t((md shr Md_Modemmm) and 3);
        end;
  end;

  { AA }
  c := (md shr Md_AA) and 3;
  if c<>2 then
    begin
      { sep }
      inc(dest[0]); dest[length(dest)] := sep;
      if c=1 then Str0Int(dest,a,4) { MMMM }
      else
        begin
          a := 100-(((a div 100)+1)*100-a); { que les centaines ! }
          Str0Int(dest,a,2);
        end;
    end;

  if ((md shr Md_ChgChar) and 1)=0 then _StrChgChar(dest,deb,255,'0','O');

end;

procedure StrPackDate( var dest : string; date : longint; md : word );
type LongRec = record
         PFaible, PFort : word;
       end;
begin
  StrDate(dest,
          LongRec(date).PFort and 31,                  { jour }
          (LongRec(date).PFort shr 5) and 15,          { mois }
          ((LongRec(date).PFort shr 9) and 127)+1980,  { anne }
          md);
end;

procedure StrTime( var dest : string; h, m, s, s100, md : word );
  { x x x x xx                                           }
  { | | | | |->sparateur: 0=>':' 1=>' ' 2=>'-' 3=>#9    }
  { | | | |->centime: 0=>rien 1=>affiche                }
  { | | |->seconde: 0=>rien 1=>affiche                   }
  { | |->heure: 0=>0H 1=>_H                              }
  { |->0=>0->O  1=>rien                                  }

  const Md_ChgChar   = 5;
        Md_mHH       = 4;
        Md_SS        = 3;
        Md_11        = 2;

var ChgChar : boolean;
    sep     : char;
    deb     : word;
    i       : word;
begin
  deb := length(dest)+1;

  case md and 3 of
    0 : sep := ':';
    1 : sep := ' ';
    2 : sep := '-';
    3 : sep := #09;
  end;

  { HH }
  if ((md shr Md_mHH) and 1)<>0 then
    begin
      i := length(dest)+1; { note }
      Str_Int(dest,h,2);
    end
  else Str0Int(dest,h,2);

  { sep }
  inc(dest[0]); dest[length(dest)] := sep;

  { MM }
  Str0Int(dest,m,2);

  if ((md shr Md_SS) and 1)<>0 then
    begin { affiche les secondes (& co ) }
      { sep }
      inc(dest[0]); dest[length(dest)] := sep;
      Str0Int(dest,s,2);
      if ((md shr Md_11) and 1)<>0 then
        begin
          { sep }
          inc(dest[0]); dest[length(dest)] := sep;
          Str0Int(dest,s100,2);
        end;
    end;

  if ((md shr Md_ChgChar) and 1)=0 then _StrChgChar(dest,deb,255,'0','O');

end;

procedure StrPackTime( var dest : string; date : longint; md : word );
type LongRec = record
         PFaible, PFort : word;
       end;
begin
  StrTime(dest,
          (LongRec(date).PFaible shr 11) and 31,       { heure }
          (LongRec(date).PFaible shr 5) and 63,        { minute }
          ((LongRec(date).PFaible and 31)+1)*2,        { seconde }
          0,                                           { centieme inexistant }
          md);
end;

function AlphaChar( c : char ) : boolean;
begin
  AlphaChar := ((c>='A') and (c<='Z')) or ((c>='a') and (c<='z'));
end;

function NumChar( c : char ) : boolean;
begin
  NumChar := (c>='0') and (c<='9');
end;


procedure InitVdtTerm( var s : EVTRec; dest : pointer; lg_max : byte );
begin
  s.AigR   := VT_NUL;
  s.cAig   := 0; { NUL }
  s.LgR    := 0;
  s.dest   := dest;
  s.dest^  := '';
  s.lg_max := lg_max;
end;

function  ExtractVdtTerm( ncar : char; var s : EVTRec ) : boolean;
type Aiguillage = (NUL,CODE,SEP,US,SS2,ESC,PRO1,PRO2,
                   PRO3,ISO2022,ISO6429,REP,FILT,US2,
                   SS2Bis);
var Aig : Aiguillage;
begin
  ncar := char(byte(ncar) and 127);
  Aig := Aiguillage(s.cAig);
  case Aig of
    NUL    : begin
               s.LgR := 0;
               s.dest^ := '';
               if ncar<#32 then
                 case ncar of
                   #27 : Aig := ESC;
                   #18 : begin
                           Aig    := REP;
                           s.AigR := VT_REP;
                         end;
                   #19 : begin
                           Aig    := SEP;
                           s.AigR := VT_SEP;
                         end;
                   #31 : begin
                           Aig    := US;
                           s.AigR := VT_US;
                         end;
                   #25 : begin
                           Aig    := SS2;
                           s.AigR := VT_SS2;
                         end;
                 else s.AigR := VT_CODE;
                 end
               else s.AigR := VT_CODE;
             end;
    ESC    :
               case ncar of
                 #$39 : begin
                          Aig    := PRO1;
                          s.AigR := VT_PRO1;
                        end;
                 #$3A : begin
                          Aig    := PRO2;
                          s.AigR := VT_PRO2;
                        end;
                 #$3B : begin
                          Aig    := PRO3;
                          s.AigR := VT_PRO3;
                        end;
                 #53..#55 : begin
                              Aig    := FILT;
                              s.AigR := VT_FILT;
                            end;
                 #32..#47 : begin
                              Aig    := ISO2022;
                              s.AigR := VT_ISO2022;
                            end;
                 #91  : begin
                          Aig    := ISO6429;
                          s.AigR := VT_ISO6429;
                        end;
               else
                 begin
                   Aig    := NUL;
                   s.AigR := VT_ESC;
                 end;
               end;
    PRO2   : Aig := PRO1;
    PRO3   : Aig := PRO2;
    ISO6429: if ncar>=#64 then Aig := NUL;
    ISO2022: if ncar>=#48 then Aig := NUL;
    US     : Aig := US2;
    SS2    : if ncar in [#65,#66,#67,#72,#75] then Aig := SS2Bis
             else Aig := NUL;
  else Aig := NUL;
  end;
  if length(s.dest^)<s.lg_max then
    begin
      inc(s.dest^[0]);
      s.dest^[length(s.dest^)] := ncar;
    end;
  inc(s.LgR);
  s.cAig := word(Aig);
  ExtractVdtTerm := Aig=NUL;
end;

function ValDec( var s : string; var result : longint ) : boolean;
var err : integer;
    x   : longint;
begin
  val(s,x,err);
  if err=0 then
    begin
      result := x;
      ValDec := TRUE;
    end
  else ValDec := FALSE;
end;

function ValHex( var s : string; var result : longint ) : boolean;
begin
  ValHex := _ValHex(s,1,result);
end;

function ValBin( var s : string; var result : longint ) : boolean;
begin
  ValBin := _ValBin(s,1,result);
end;

function ValX( var s : string; var result : longint ) : boolean;
{ traduit en fonction de s }
begin
  if s<>'' then
    case UpCase(s[1]) of
      '$' : ValX := _ValHex(s,2,result);
      '%' : ValX := _ValBin(s,2,result);
    else ValX := ValDec(s,result);
    end
  else ValX := FALSE;
end;

function ValReal( var s : string; var result : real ) : boolean;
var err : integer;
    x   : real;
begin
  val(s,x,err);
  if err=0 then
    begin
      result := x;
      ValReal := TRUE;
    end
  else ValReal := FALSE;
end;

function SepInTab( c : char; var p; lg : word ) : boolean;
var TabSep : array[1..1000] of char absolute p;
    i : word;
begin
  for i := 1 to lg do
    if c=TabSep[i] then
      begin
        SepInTab := TRUE;
        exit;
      end;
  SepInTab := FALSE;
end;

function _StrPartCount( var sour : string; var p; LgTab : word ) : word;
var TabSep    : array[1..1000] of char absolute p;
    LoadParam : boolean;
    nParam    : word;
    i         : word;
    c, Lc     : char;
begin
  if sour<>'' then
    begin
      LoadParam := FALSE;
      nParam    := 0;
      Lc        := #0;
      for i := 1 to length(sour) do
        begin
          c := sour[i];
          if LoadParam then
            begin { paramtre en cours ... }
              if SepInTab(c,TabSep,LgTab) then
                begin
                  LoadParam := FALSE;
                  Lc := c; { note le premier separateur }
                end;
            end
          else
            begin
              if SepInTab(c,TabSep,LgTab) then
                begin
                  if (c<>' ') then
                    begin
                      if (Lc<>' ') then
                        begin
                          inc(nParam); { vide }
                        end;
                      Lc := c;
                    end;
                end
              else
                begin
                  inc(nParam);
                  LoadParam := TRUE;
                end;
            end;
        end;
      if not(LoadParam) and (Lc<>' ') then inc(nParam); { car on s'arrette sur un sep de fin }
      _StrPartCount := nParam;
    end
  else _StrPartCount := 0;
end;

procedure _StrPart( var sour : string; num : word;
                    var dest : string; lg_max : word;
                    var p; lgTab : word );
var TabSep    : array[1..1000] of char absolute p;
    LoadParam : boolean;
    i, lg     : word;
    c, Lc     : char;
    deb       : word;
begin
  LoadParam := FALSE;
  Lc        := #0;
  for i := 1 to length(sour) do
    begin
      c := sour[i];
      if LoadParam then
        begin { paramtre en cours ... }
          if SepInTab(c,TabSep,lgTab) then
            begin
              if num=0 then
                begin { trouv ! }
                  lg := i-deb;
                  if lg>lg_max then lg := lg_max;
                  dest[0] := char(lg);
                  move(sour[deb],dest[1],lg);
                  exit;
                end;
              Lc := c;
              LoadParam := FALSE;
            end;
        end
      else
        begin
          if SepInTab(c,TabSep,LgTab) then
            begin
              if (c<>' ') then
                begin
                  if (Lc<>' ') then
                    begin
                      dec(num); { vide }
                      if num=0 then
                        begin { on  trouv le param, mais vide ! }
                          dest := '';
                          exit;
                        end;
                    end;
                  Lc := c;
                end;
            end
          else
            begin
              LoadParam := TRUE;
              dec(num);
              deb := i;
            end;
        end;
    end;
  if LoadParam and (num=0) then
    begin { paramtre en cours ... }
      lg := (i+1)-deb;
      if lg>lg_max then lg := lg_max;
      dest[0] := char(lg);
      move(sour[deb],dest[1],lg);
    end
  else dest := '';
end;

function _StrPartLength( var sour : string; num : word;
                         var p; lgTab : word ) : word;
var TabSep    : array[1..1000] of char absolute p;
    LoadParam : boolean;
    i         : word;
    c, Lc     : char;
    deb       : word;
begin
  LoadParam := FALSE;
  Lc        := #0;
  for i := 1 to length(sour) do
    begin
      c := sour[i];
      if LoadParam then
        begin { paramtre en cours ... }
          if SepInTab(c,TabSep,lgTab) then
            begin
              if num=0 then
                begin { trouv ! }
                  _StrPartLength := i-deb;
                  exit;
                end;
              Lc := c;
              LoadParam := FALSE;
            end;
        end
      else
        begin
          if SepInTab(c,TabSep,lgTab) then
            begin
              if (c<>' ') then
                begin
                  if (Lc<>' ') then
                    begin
                      dec(num); { vide }
                      if num=0 then
                        begin { on  trouv le param, mais vide ! }
                          _StrPartLength := 0;
                          exit;
                        end;
                    end;
                  Lc := c;
                end;
            end
          else
            begin
              LoadParam := TRUE;
              dec(num);
              deb := i;
            end;
        end;
    end;
  if LoadParam and (num=0) then { trouv ! }
     _StrPartLength := (i+1)-deb
  else _StrPartLength := 0;
end;

procedure _StrRest( var sour : string; num : word;
                    var dest : string; lg_max : word;
                    var p; lgTab : word );
var TabSep    : array[1..1000] of char absolute p;
    LoadParam : boolean;
    i, lg     : word;
    c, Lc     : char;
label _ok;
begin
  if (sour<>'') and (num>0) then
    begin
      LoadParam := FALSE;
      Lc        := #0;
      for i := 1 to length(sour) do
        begin
          c := sour[i];
          if LoadParam then
            begin { paramtre en cours ... }
              if SepInTab(c,TabSep,lgTab) then
                begin
                  Lc := c;
                  LoadParam := FALSE;
                end;
            end
          else
            begin
              if SepInTab(c,TabSep,LgTab) then
                begin
                  if num=1 then goto _ok;
                  if (c<>' ') then
                    begin
                      if (Lc<>' ') then dec(num); { vide }
                      Lc := c;
                    end;
                end
              else
                begin
                  LoadParam := TRUE;
                  dec(num);
                  if num=0 then
                    begin { trouv ! }
                _ok:
                      lg := (length(sour)+1)-i;
                      if lg>lg_max then lg := lg_max;
                      dest[0] := char(lg);
                      move(sour[i],dest[1],lg);
                      exit;
                    end;
                end;
            end;
        end;
    end;
  dest := '';
end;

function _StrRestLength( var sour : string; num : word;
                         var p; lgTab : word ) : word;
var TabSep    : array[1..1000] of char absolute p;
    LoadParam : boolean;
    i         : word;
    c, Lc     : char;
label _ok;
begin
  if (sour<>'') and (num>0) then
    begin
      LoadParam := FALSE;
      Lc        := #0;
      for i := 1 to length(sour) do
        begin
          c := sour[i];
          if LoadParam then
            begin { paramtre en cours ... }
              if SepInTab(c,TabSep,lgTab) then
                begin
                  Lc := c;
                  LoadParam := FALSE;
                end;
            end
          else
            begin
              if SepInTab(c,TabSep,LgTab) then
                begin
                  if num=1 then goto _ok;
                  if (c<>' ') then
                    begin
                      if (Lc<>' ') then dec(num); { vide }
                      Lc := c;
                    end;
                end
              else
                begin
                  LoadParam := TRUE;
                  dec(num);
                  if num=0 then
                    begin { trouv ! }
                _ok:
                      _StrRestLength := (length(sour)+1)-i;
                      exit;
                    end;
                end;
            end;
        end;
    end;
  _StrRestLength := 0;
end;

procedure StrRest( var sour : string; num : word;
                   var dest : string; lg_max : word );
begin
  _StrRest(sour,num,dest,lg_max,StdSep,LgStdSep);
end;

function StrRestLength( var sour : string; num : word ) : word;
begin
  StrRestLength := _StrRestLength(sour,num,StdSep,LgStdSep);
end;

function StrPartCount( var sour : string ) : word;
begin
  StrPartCount := _StrPartCount(sour,StdSep,LgStdSep);
end;

procedure StrPart( var sour : string; num : word;
                   var dest : string; lg_max : word );
begin
  _StrPart(sour,num,dest,lg_max,StdSep,LgStdSep);
end;

function StrPartLength( var sour : string; num : word ) : word;
begin
  StrPartLength := _StrPartLength(sour,num,StdSep,LgStdSep);
end;

function _StrPartVal( var sour : string; num : word;
                      var result : longint; default : longint;
                      var p; lgTab : word ) : boolean;
var TabSep : array[1..1000] of char absolute p;
    s   : string[11];
    err : word;
    x   : longint;
begin
  _StrPart(sour,num,s,sizeof(s)-1,TabSep,lgTab);
  StrPlane(s);
  if s='' then
    begin
      result := default;
      _StrPartVal := TRUE;
    end
  else
    begin
      val(s,x,err);
      if err=0 then
        begin
          result := x;
          _StrPartVal := TRUE;
        end
      else _StrPartVal := FALSE;
    end;
end;

function StrPartVal( var sour : string; num : word;
                     var result : longint; default : longint ) : boolean;
begin
  StrPartVal := _StrPartVal(sour,num,result,default,StdSep,LgStdSep);
end;

function DayNumber( j, m, a : word ) : longint;
{ (jour) j=1..31  (mois) m=1..12  (anne) a=1582..65535 }
{ la date de rference est le Dimanche 17/10/1582 }
{ Pour cette date, le numro de jour renvoy est 0 }
{ On dduit le jour de la semaine en faisant NumDay mod 7, avec Dimanche=0 }
begin
  if m<3 then
    begin
      inc(m,9);
      dec(a);
    end
  else dec(m,3);
  DayNumber := ((1461*longint(a)) div 4)-((3*(1+(a div 100))) div 4)+
               ((306*m+5) div 10)+j-1-578043;
end;

function WeekDay( j, m, a : word ) : word;
{ jour de la semaine: Dimanche=0 }
begin
  WeekDay := word(DayNumber(j,m,a) mod 7);
end;

function DayNumberPack( d : longint ) : longint;
{ la date fournit est au format compact DOS-FILE }
type LongRec = record
         PFaible, PFort : word;
       end;
begin
  DayNumberPack := DayNumber(LongRec(d).PFort and 31,           { jour }
                             (LongRec(d).PFort shr 5) and 15,   { mois }
                             ((LongRec(d).PFort shr 9) and 127)+1980); { anne }
end;

function WeekDayPack( d : longint ) : word;
{ la date fournit est au format compact DOS-FILE }
type LongRec = record
         PFaible, PFort : word;
       end;
begin
  WeekDayPack := WeekDay(LongRec(d).PFort and 31,           { jour }
                         (LongRec(d).PFort shr 5) and 15,   { mois }
                         ((LongRec(d).PFort shr 9) and 127)+1980); { anne }
end;


procedure StrOneSpace( var sour : string );
{ supprime les espaces superflus }
var i, j : word;
    last : char;
begin
  j := 0;
  last := ' ';
  for i := 1 to length(sour) do
    begin
      if (sour[i]=' ') then Last := ' '
      else
        begin
          if (j>0) and (Last=' ') then
            begin
              inc(j);
              sour[j] := ' ';
            end;
          inc(j);
          sour[j] := sour[i];
          last := '!';         { <> de ' ' }
        end;
    end;
  sour[0] := char(j);
end;


procedure StrJoin( var p; lg, nb : word; var dest : string; lg_max : word );
{ join un ensemble de chaine de facon "intelligente" }
{ c-a-d : 'ABCD' + 'A' + 'CD-' + 'KD' donne 'ABCDA CDKD' (si lg=4) }
type Buffer = array[0..1000] of byte;
var v       : ^string;
    i       : word;
    LastLen : word;
    Last    : char;
    len     : word;
    l       : word;
begin
  dest    := '';
  len     := 0;
  Last    := ' ';
  LastLen := 0;
  i       := 1;
  while (len<lg_max) and (i<=nb) do
    begin
      v := @Buffer(p)[(i-1)*(lg+1)];
      l := length(v^);
      if l<>0 then
        begin
          if (LastLen>0) and (Last<>'-') and (LastLen<lg) and (Last<>' ') then
            begin
              inc(len);
              dest[len] := ' ';
            end;
          if len+l>lg_max then l := lg_max-len;
          move(v^[1],dest[len+1],l);
          inc(len,l);
          LastLen := l;
          Last := dest[len];
          if Last='-' then
            begin
              dec(len);
              dec(LastLen);
            end;
        end;
      inc(i);
    end;
  dest[0] := char(len);
end;


Procedure UnJoinStr( Var sour; lg_s : Word; Var dest; lg_d : Byte; nb_d : Word;
                     SpcTrunc, OptSpace, Centre : Boolean );
{ ABC__DEF_F_GH_I  =>  ABC|__D|EF_|F_G|H_I }
Var s     : Array[0..65534] Of Char Absolute sour;
    d     : Array[0..65534] Of Byte Absolute dest;
    iRead : Word;
    iWrite: Byte;
    nLig  : Word;
    Lastc : Char;
    lg    : Word;
    EndB  : Boolean;
    Ligne : ^String;
    deb   : Word;
    x     : Word;
Begin
 iRead := 0;
 nLig  := 0;
 Lastc := ' ';

 While (nLig<nb_d) Do
  Begin
   Ligne := @d[nLig*(lg_d+1)];
   iWrite := 0;
   EndB := FALSE;

   While (iWrite<lg_d) And Not(EndB) Do
    Begin
     { determine la longueur du mot suivant }
     deb := iRead;
     lg := 0;
     If (deb<lg_s) Then
      Begin
       If s[deb]=' ' Then lg := 1
       Else
        Begin
         Repeat
          Inc(lg);
         Until (deb+lg>=lg_s) Or (s[deb+lg]=' ');
        End;
      End;

     If lg=0 Then EndB := TRUE             { Plus rien  lire... }
     Else
      Begin
       If OptSpace And (s[iRead]=' ') Then
        Begin { cas special (sparateur) }
         If Lastc=' ' Then
          Begin { decalage }
           Inc(iRead,lg);
          End
         Else
          Begin
           Move(s[iRead],Ligne^[iWrite+1],lg);
           Inc(iWrite,lg);
           Inc(iRead,lg);
           Lastc := ' ';
          End;
        End
       Else
        Begin
         If SpcTrunc Then
          Begin
           If iWrite+lg>lg_d Then
            Begin { pas assez de place ... }
             If (nLig+1>=nb_d) Or (iWrite=0) Then
              Begin { corriger la taille }
               lg := lg_d-iWrite;
               Lastc := '@';
              End
             Else
              Begin
               lg := 0;
               Lastc := ' ';
               EndB := TRUE;  { ligne suivante }
              End;
            End
           Else Lastc := '@';
          End
         Else
          Begin
           If iWrite+lg>lg_d Then lg := lg_d-iWrite;
           Lastc := '@';
          End;

         If lg>0 Then
          Begin
           Move(s[iRead],Ligne^[iWrite+1],lg);
           Inc(iWrite,lg);
           Inc(iRead,lg);
          End;
        End;

      End;

    End;

   (*
   If OptSpace Then
   *)
   While (iWrite>0) And (Ligne^[iWrite]=' ') Do Dec(iWrite);
   Ligne^[0] := Char(iWrite);

   If Centre Then
    Begin { Centrer le texte ... }
          { c-a-d :  ABCDEFxxxxx => xxABCDEFxxx }
     StrPlane(Ligne^);
     x := ((lg_d-length(Ligne^)) Div 2)+1;
     If x>1 Then
      Begin
       Move(Ligne^[1],Ligne^[x],Length(Ligne^));
       FillChar(Ligne^[1],x-1,' ');
       Inc(Ligne^[0],x-1);
      End;
    End;

   Inc(nLig);
  End;
End;



end.
